
/**
 * @author Pawel P. Wozniak
 * Class changes 3 letter symbols of aminoacids into 1 letter symbol and backward.
 */
public class AANameConverter 
{
	private char[] AA1 = {'A','C','D','E','F','G','H','I','K','L','M','N','P','Q','R','S','T','V','W','Y', 'M'}; //Table of aa symbols + gap
	private String[] AA3 = {"ALA","CYS","ASP","GLU","PHE","GLY","HIS","ILE","LYS","LEU","MET","ASN","PRO","GLN","ARG","SER","THR","VAL","TRP","TYR", "MSE"};
	
	/**
	 * @category Changes 3 letter symbol of aminoacids into 1 letter symbol
	 * @param aa - 3 letter code of aminoacid
	 * @return 1 letter code of aminoacid aa (if bug then return 'X')
	 */
	public char AA3toAA1(String aa)
	{
		int AANmb = AA3.length;
		for(int i=0; i<AANmb; i++)
		{
			if(AA3[i].equals(aa))
			{
				return AA1[i];
			}
		}
		return 'X';
	}
	
	/**
	 * @category Changes 1 letter symbol of aminoacids into 3 letter symbol
	 * @param aa - 1 letter code of aminoacid
	 * @return 3 letter code of aminoacid aa (if bug then return 'XXX')
	 */
	public String AA1toAA3(char aa)
	{
		int AANmb = AA1.length;
		for(int i=0; i<AANmb; i++)
		{
			if(AA1[i] == aa)
			{
				return AA3[i];
			}
		}
		return "XXX";
	}
}
