import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.List;


/**
 * Sort DCA results and provide sorted values and their indexes.
 * @author Pawel P. Wozniak
 */
public class TopMethods
{
	private List<Integer> posDca1 = null;
	private List<Integer> posDca2 = null;
	private int[] gdcaSortInd = null;
	private double[] gdcaSortVal = null;
	
	public void gatherSortedGplmdca(String folderPath, int pos1Col, int pos2Col, int dcaCol, String splitRegex)
	{
		gatherSortedGplmdcaFinal(folderPath, pos1Col, pos2Col, dcaCol, splitRegex);
	}
	
	public void gatherSortedGplmdca(String folderPath)
	{
		gatherSortedGplmdcaFinal(folderPath, 0, 1, 2, ",");
	}
	
	private void gatherSortedGplmdcaFinal(String folderPath, int pos1Col, int pos2Col, int dcaCol, String splitRegex)
	{
		FileReader fr;
    	BufferedReader br;
    	String line;
    	String[] splitter;
    	List<Double> gplmdca = new ArrayList<Double>();
    	posDca1 = new ArrayList<Integer>();
    	posDca2 = new ArrayList<Integer>();
		try
		{
			fr = new FileReader(folderPath);
			br = new BufferedReader(fr);
			while((line = br.readLine()) != null)
			{
				splitter = line.split(splitRegex);
				posDca1.add(Integer.parseInt(splitter[pos1Col]));
				posDca2.add(Integer.parseInt(splitter[pos2Col]));
				gplmdca.add(Double.parseDouble(splitter[dcaCol]));
				if(splitter[2].equals("NaN"))
				{
					br.close();
					throw new Exception("gplmdca contains NaN");
				}
			}
			
			QS_double qs = new QS_double(gplmdca);
			gdcaSortInd = qs.getIndex();
			gdcaSortVal = qs.getQSciag();
			br.close();
			fr.close();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	public List<Integer> getPosDca1() {
		List<Integer> copy = new ArrayList<Integer>(posDca1.size());
	    for(Integer c : posDca1)
	    {
	        copy.add(c);
	    }
		return copy;
	}

	public List<Integer> getPosDca2() {
		List<Integer> copy = new ArrayList<Integer>(posDca2.size());
	    for(Integer c : posDca2)
	    {
	        copy.add(c);
	    }
		return copy;
	}

	public int[] getGdcaSortInd() {
		return gdcaSortInd.clone();
	}
	
	public double[] getGdcaSortVal() {
		return gdcaSortVal.clone();
	}
}
